## Script (Python) "pay_online"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=
##title=
##
# $Id: pay_interswitch.py 2619 2007-11-10 17:39:36Z henrik $
"""
pay online
"""
from urllib import urlencode
import logging
logger = logging.getLogger('Skins.pay_interswitch')
import DateTime

if context.portal_membership.isAnonymousUser():
    return None

try:
    from Products.zdb import set_trace
except:
    def set_trace():
        pass
request = context.REQUEST
wftool = context.portal_workflow
students = context.portal_url.getPortalObject().campus.students


student_id = context.getStudentId()
student = getattr(students,student_id)

student_record = context.students_catalog.getRecordByKey(student_id)
#amount,description = context.getSchoolFee(student_record.faculty,student_record.session,student_record.course)
info = {}
info['student'] = student_record
info['payment_possible'] = False
info['amount'] = '0'
info['bank'] = ''
info['type_description'] = ''
info['pay_bill_to'] = ''
fee_dict = context.getSchoolFee(student_record)
fulltime = student_record.mode.endswith('_ft')

if not fee_dict:
    return context.interswitch_form(info=info)

info['site_id'] = '115'
info['currency_id'] = '566'
pay_item_id = "11500"

#info['type_code'] = sbrain.course  #type_code is redundant and will be removed soon
info['bank'] = ''
info['payment_possible'] = True
info['type_description'] = fee_dict['description']
info['pay_bill_to'] = student_record.name
info['student_id'] = student_id
info['student_name'] = student_record.name
info['type'] = 'online'
info['status'] = 'started'
info['session_id'] = fee_dict['next_session_id']
info['item'] = student_record.course
info['category'] = 'schoolfee'
info['student_email'] = student_record.email
now = DateTime.DateTime()
info['date'] = now
info['pay_ship_to'] = "Federal College of Education [Special] Oyo"
timestamp = "%d" % int(now.timeTime()*1000)
info['order_id'] = "%s%s" % (student_id[1:],timestamp)
p_id = "p%s" % timestamp
info['surcharge'] = interswitch_amount = 300
amount = fee_dict['all']
bt_amount = 2000
fceoyo_split = 500
info['amount'] = amount + bt_amount + fceoyo_split

#getSchoolFee provides pure school fee, the other fees have to be added
total_amount = 100* (amount + interswitch_amount + bt_amount + fceoyo_split) 

if student_id is None:
    return context.REQUEST.RESPONSE.redirect("%s/srp_anonymous_view" % context.portal_url())

if True:
    info['action'] = "https://webpay.interswitchng.com/paydirect/webpay/pay.aspx"
else:
    #pass
    #return None
    info['action'] = "%s/payments/%s/simulate_callback" % (student.absolute_url(),p_id)


if "payments" not in student.objectIds():
    student.invokeFactory('PaymentsFolder','payments')
    payments = getattr(student,'payments')
    d = {}
    d['Title'] = 'Payments'
    payments.getContent().edit(mapping=d)
    wftool.doActionFor(payments,'open')
else:
    payments = getattr(student,'payments')
if request.has_key('epayment'):
    return context.interswitch_form(info=info)


payments.invokeFactory('Payment', p_id)
payment = getattr(payments,p_id)
wftool.doActionFor(payment,'open')
d = {}
d.update(info)
payment.getContent().edit(mapping=d)


info['callback_url'] = "%s/payments/%s/interswitch_cb?echo=%s" % (student.absolute_url(),
                                                                  p_id,
                                                                  p_id)
                                                                  

                                                          

logger.info('%(student_id)s initiated online school fee payment with order_id %(order_id)s and callback url %(callback_url)s' % info)
payment_fields = (('product_id','site_id'),
                  ('site_redirect_url','callback_url'),
                  ('Currency','currency_id'),
                  ('cust_id','student_id'),
                  ('cust_id_desc','type_description'),
                  ('cust_name','student_name'),
                  ('txn_ref','order_id'),
                  ('Amount','amount'),
                  )
args = {}
for arg,field in payment_fields:
    args[arg] = info[field]

    


xmldict = {}
xmldict['detail_ref'] = args['txn_ref']
xmldict['department'] = student_record.department
xmldict['faculty'] = student_record.faculty
xmldict['amount'] = "%d" % int(100*amount)
xmldict['bt_amount'] = "%d" % int(100*bt_amount)

if student_record.mode in ('ug_sw','prence',):
    xmldict['fceoyo_acct'] = "0061001000021076"
    xmldict['bank_id'] = '89'
elif student_record.mode in ('ug_ft',):
    xmldict['fceoyo_acct'] = "3030010073"
    xmldict['bank_id'] = '125'
else:
    xmldict['fceoyo_acct'] = "0000000000000"
    xmldict['bank_id'] = '0'

xmldict['fceoyo_split'] = "%d" % int(100*fceoyo_split)


xmltext = """<payment_item_detail>
<item_details detail_ref="%(detail_ref)s" college="fceoyo" department="%(department)s" faculty="%(faculty)s" >
<item_detail item_id="1" item_name="FCEOyo School Fee" item_amt="%(amount)s" bank_id="%(bank_id)s" acct_num="%(fceoyo_acct)s" />
<item_detail item_id="2" item_name="FCEOyo Split" item_amt="%(fceoyo_split)s" bank_id="125" acct_num="3030010076" />
<item_detail item_id="3" item_name="BT" item_amt="%(bt_amount)s" bank_id="89" acct_num="0061001000021095" />
</item_details>
</payment_item_detail>""" % xmldict

info['xml_data'] = """<input type="hidden" name="xml_data" value='%s'  />""" % xmltext

args['Amount'] = "%d" % (total_amount)
args['site_name'] = "fceoyo.waeup.org"
args['cust_name_desc'] = "Student Name"
args['pay_item_id'] = pay_item_id
args['pay_item_name'] = "FCE[Special] Oyo Tuition Payments"
args['payment_params'] = 'college_split'
#args['xml_data'] = ''
#args['xml_data'] = xmltext   # info['xml_data']can be used instead
info['args'] = args

return context.goto_interswitch_form(info=info)

